@echo off

rem read common settings
call bin\common.bat

rem check command line parameters
if "%1"=="sb" goto save_reg_conf_bin
if "%1"=="s" goto save_reg_conf

if "%1"=="rb" goto restore_reg_conf_bin
if "%1"=="r" goto restore_reg_conf

if "%1"=="l" goto list_targets
if "%1"=="list" goto list_targets

:usage

rem bad command line parameters. print help
echo "Usage:"
echo "rconf [action] [target]"
echo "  actions:"
echo "    s    - save registry settings of target app"
echo "    sb   - save registry settings and required binaries of target app"
echo "    r    - restore registry settings of target app"
echo "    rb   - restore registry settings and required binaries of target app"
echo "    l    - show list of known target app"
echo "  target:"
echo "    any item listed in %targets% or 'all'"

goto quit

:save_reg_conf_bin

set with_bin="1"
echo with binaries

:save_reg_conf

rem try save settings.
rem empty target is not allowed.
rem 'all' target will save all targets listed in %targets%

if "x%2"=="x" goto usage
if "%2"=="all" goto save_all

set savefile=%cfg%\%2.reg
set savedir=%cfg%\%2.bin

rem check if requested config exists
if not exist ini\%2.reglist goto save_ini_notfound

echo REGEDIT4 > %savefile%
for /F "eol=; delims=[" %%i in (ini\%2.reglist) do @call bin\helper0.bat %%i %2
rem check if registry settings must be filtered
if not exist ini\%2.badvarlist goto save_no_filter
for /F "eol=; delims=[" %%i in (ini\%2.badvarlist) do @call bin\helper1.bat %%i %2
:save_no_filter
if not exist ini\%2.reqvarlist goto save_no_filter2
for /F "eol=; tokens=1* delims=[]" %%i in (ini\%2.reqvarlist) do @call bin\helper2.bat %%i %%j %2
:save_no_filter2
if not exist ini\%2.binlist goto save_no_bins
if "x%with_bin%"=="x" goto save_no_bins
if not exist %savedir% mkdir %savedir%
for /F "eol=; tokens=1* delims=[]" %%i in (ini\%2.binlist) do @call bin\helper3.bat %%i %%j %2
:save_no_bins
echo %2

goto quit

:save_ini_notfound

rem cannot find config file with registry key list
echo %2 settings not found
goto quit

:save_all

rem 'all' target for save was spacified
for /F "eol=;" %%i in (%targets%) do @call rconf.bat s %%i
goto quit

:list_targets

rem list available targets
echo Available targets:
for /F "eol=;" %%i in (%targets%) do @echo %%i

goto quit

:restore_reg_conf_bin

set with_bin="1"
echo with binaries

:restore_reg_conf

rem try restore settings.
rem empty target is not allowed.
rem 'all' target will restore all targets listed in %targets%
if "x%2"=="x" goto usage
if "%2"=="all" goto restore_all

set savefile=%cfg%\%2.reg
if not exist %savefile% goto restore_nonexistant

echo %2
start/wait regedit -s %savefile%
if not exist ini\%2.binlist goto restore_no_bins
if "x%with_bin%"=="x" goto restore_no_bins
if not exist %savedir% mkdir %savedir%
for /F "eol=; tokens=1* delims=[]" %%i in (ini\%2.binlist) do @call bin\helper4.bat %%i %%j %2
:restore_no_bins

goto quit

:restore_nonexistant

rem nonexistant target was requested for restore
echo %2 settings not found
goto quit

:restore_all

rem 'all' target for restore was specified
for /F "eol=;" %%i in (%targets%) do @call rconf.bat r %%i
goto quit

:quit
